﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;


namespace FlujoTags.Workflow1
{
    public sealed partial class Workflow1 : SequentialWorkflowActivity
    {
       
        
        public Workflow1()
        {
           
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties workflowProperties = new SPWorkflowActivationProperties();


        private void codeActivity1_ExecuteCode(object sender, EventArgs e)
        {
            //try
            //{
                string[] NuevosTags;
                string[] TagsEliminados;

                
                //SPList miLista = miWeb.Lists["Lista de Proyectos"];
                SPList miLista = workflowProperties.List;

                workflowProperties.Item["Info de Tags"] = "";
               string aux,aux2;
                try
                {
                     aux = workflowProperties.Item["Tags"].ToString();
                }
                catch{
                //esta vacio el campo de tags
                    aux=null;
                }
                try{
                
                    aux2 = workflowProperties.Item["CopiaTags"].ToString();}
                catch{
                //esta vacio el campo de copia de tags, o sea los tags anteriores
                    aux2=null;
                
                }

                if ((aux2==null)&&(aux==null))
                    return;
               
                if (aux2 == null) {
                   
                    NuevosTags =workflowProperties.Item["Tags"].ToString().Split(',');
                    foreach (string tag in NuevosTags) {
                        addTags(tag);
                    }
                    
                   

                }

                else if (aux == null) {

                    TagsEliminados =aux2.ToString().Split(',');
                    foreach (string tag in TagsEliminados){
                        deleteTags(tag);

                    }
                    

                }

                else if (!(aux2.Equals(aux)))
                {
                    string[] OldTable,NewTable;
                    
                    OldTable=aux2.Split(',');
                    NewTable = aux.Split(',');
                    int i=0;




                    //Busqueda de tags que han sido eliminados
                    
                    foreach (string Old in OldTable) {
                        bool b = true;
                        foreach (string New in NewTable){
                            if (Old.ToUpper().Trim().Equals(New.ToUpper().Trim()))
                                b=false;         
                        }
                        if (b) deleteTags(Old.Trim());
                    }

                    //Busqueda de tags que han sido introducidos
                    if (workflowProperties.Item["Info de Tags"].ToString()!="")            
                        workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "\n <br>";
                   
                    i = 0;
                    foreach (string New in NewTable)
                    {
                        bool b = true;
                        foreach (string Old in OldTable)
                        {
                            if (Old.ToUpper().Trim().Equals(New.ToUpper().Trim()))
                                b = false;
                        }
                        if (b)  addTags(New); 

                    }
                    

                  
                }

                workflowProperties.Item["CopiaTags"] = aux;
                workflowProperties.Item.Update();
            }
            //catch (Exception ex) { 
            
            //}
        


        public void addTags(string tag) {

            //Aqui comprobar en el registro y sino buscar en una pagina

            //

            //Mostrar en columna
            //SPList miLista = currentSite.OpenWeb().Lists["Lista de Proyectos"];

            



            if (!(workflowProperties.Item["Info de Tags"].ToString().Contains("Tags añadidos")))
           
                workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "Tags añadidos: ";
           

            if (TagEnRefExternas(tag))
                workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "  <a href=\"" + workflowProperties.Web.Url + "/SitePages/resultado.aspx?tags=" + tag.Replace("#", "%23") + "\">" + tag + "</a>";

            
            else
            {
                workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString()+"<br> Buscando referentes para " +tag;
                SPList listaPaginas=workflowProperties.Web.Lists["Paginas favoritas"];
                SPListItemCollection items = listaPaginas.GetItems();
                if (items.Count == 0) 
                {
                    GestorBusqueda gestor = new GestorBusqueda("Bing", "www.codeplex.com", tag,workflowProperties.Web);
                    gestor.buscar();
                    workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString()  + "<br>" +gestor.getEncontrados().ToString() + " resultados de busqueda en Codeplex ";
                    workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + " <br> <a href=\"" + workflowProperties.Web.Url + "/SitePages/resultado.aspx?tags=" +tag.Replace("#","%23")+ "\">" + tag + "</a>";
                }
                else
                {
                    int x = 3;
                    if (items.Count < 3)
                        x = items.Count;
                    for (int i = 0; i < x; i++)
                    {
                        SPListItem item = items[i];
                        GestorBusqueda gestor = new GestorBusqueda(item["Motor busqueda"].ToString(), item["Título"].ToString(), tag,workflowProperties.Web);
                        gestor.buscar();

                        workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "<br>" + gestor.getEncontrados().ToString() + " resultados de busqueda en " + item["Título"] + " con " + item["Motor busqueda"];
                    }
                    string ahref = workflowProperties.Web.Url + "/SitePages/resultado.aspx?tags=" + tag.Replace("#", "%23");
                    
                    workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + " <br> <a href=\"" + ahref + "\">" + tag + "</a>";
                }
             

            }

            
           
            
         

        }
       
        public void deleteTags(string tag) {

            //Comprobar si hay otro proyecto con ese tag, sino eliminar todas sus referencias
            //
            if (!(workflowProperties.Item["Info de Tags"].ToString().Contains("Tags eliminados")))

                workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "Tags eliminados: ";


            if (TagEnProyectosInternos(tag))
            

                workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "   " + tag;
            
            else {

                if (TagEnRefExternas(tag)) { 
                
                    //Eliminar todas las referencias
                    EliminarReferenciasTag(tag);
                    workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "   " + tag+" (Eliminados referentes externos)";
                }
                else
                    workflowProperties.Item["Info de Tags"] = workflowProperties.Item["Info de Tags"].ToString() + "   " + tag;
            
            
            }



          
           
            
        
        }


        public bool TagEnProyectosInternos(string tag) {
            
            SPList miLista = workflowProperties.List;
            
           SPQuery query=new SPQuery();
            query.Query="<Where><Contains><FieldRef Name='Tags'/>" + "<Value Type='Text'>" + tag + "</Value></Contains></Where>";
            SPListItemCollection items = miLista.GetItems(query);
            if (items.Count > 0)
                return true;
            else        
                return false;
        }

        public bool TagEnRefExternas(string tag) {

            SPSite miSitio = new SPSite(workflowProperties.SiteId);      
            SPWeb miWeb = miSitio.OpenWeb(workflowProperties.WebId);
            SPList lista = miWeb.Lists["RegistroBusqueda"];     
            SPQuery query=new SPQuery();
           
            query.Query = "<Where><Contains><FieldRef Name='posibles_x0020_tags'/>" + "<Value Type='Text'>" + tag + "</Value></Contains></Where>";
          
            SPListItemCollection items=lista.GetItems(query);
            if (items.Count>0)
                return true;
            else
                return false;
        
        }


        public void EliminarReferenciasTag(string tag) {
            SPSite miSitio = new SPSite(workflowProperties.SiteId);
            SPWeb miWeb = miSitio.OpenWeb(workflowProperties.WebId);
            SPList lista = miWeb.Lists["RegistroBusqueda"];
            SPQuery query = new SPQuery();
           
            query.Query = "<Where><Contains><FieldRef Name='posibles_x0020_tags'/>" + "<Value Type='Text'>" + tag + "</Value></Contains></Where>";
            SPListItemCollection items =lista.GetItems(query);
            SPListItem item;
            for(int i=0;i<items.Count;i++){
                item=items[i];
                if (item["posibles tags"].ToString().ToUpper().Trim().Equals(tag.ToUpper().Trim())) { 
                        lista.Items.DeleteItemById(item.ID);
                
                }
            }

                
                    
            
            
            }
            
        
    }
}
