﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.IO;
using System.Net;
using System.Web.Services;
using System.Xml;


//EL SERVICIO LO HE PUBLICADO EN http://localhost:1183/Service1.asmx?
namespace MiWebService
{


    public struct fila
    {
        public string titulo;
        public string URL;
        public string descripcion;

    } 
    /// <summary>
    /// Hare que este web service se conecte a codeplex y tenga las funcionalidades de buscar 
    /// </summary>
    /// 
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
     [System.Web.Script.Services.ScriptService]
    public class Service1 : System.Web.Services.WebService
    {
        
       

        //Comentarios:
        //Esta clase representaria una busqueda, estaría bien que se comporte como una clase
        // en ese caso cada instancia guardaria los resultados de esa buskeda, asi komo un atributo privado para indicar la URL
        //y poder ver si hay mas paginas mas proyectos. Tambien la opcion de la base de datos

        public fila[] resultado=new fila[100];

        [WebMethod]

        public string getResultados(){
            string final = string.Empty;

            for (int i=0;resultado[i].URL!=null;i++){
               //error aqui al depurar
                final = final +resultado[i].URL +"\n";
                //falta añadir los titulos +resultado[i].titulo+" "
            }
            return final;
        }

        
      

        //funciones que me s ocurren

        //buscar por tags, donde tendremos
            //buscar URLs q devuelve una tabala de URLs
            //buscar titulos, mas de lo meme
            //demas campos
        //pasar pagina
        //hay next pag?

         
        //mejor no sacar ningun array pork luego es mas lio a la hora de usar el web service desde otro programa
        [WebMethod]
        public  string buscar(string palabras){
            
            //me conecto a la web de busqueda de codeplex con sus palabras
            StreamReader contenido= leerPaginaWeb("http://www.codeplex.com/site/search?projectSearchText="+palabras+"&sortBy=Relevance&licenses=|");
           
            int contador = 0;
            
            //Ahora intentare leer en bloques para sacar las URLS y los titulos
            //los busca solo en pag 1
            string line = string.Empty;
            //string[] listaURL;
           
            //listaURL= new string[50];
            string final = string.Empty;
            
            string URL = string.Empty;
            string titulo = string.Empty;
            
            while ((line = contenido.ReadLine()) != null)
            {
                if (line.Contains("tr class"))
                {
                    contenido.ReadLine();
                    contenido.ReadLine();
                    line = contenido.ReadLine();

                    int posicion = line.IndexOf("http:");
                    if (posicion > 0)
                    {

                        line = line.Substring(posicion);
                        this.resultado[contador].URL = devolverUrl(line);
                        posicion = line.IndexOf(">");
                        line = line.Substring(posicion);
                        this.resultado[contador].titulo=devolverTitulo(line);
                        contenido.ReadLine();
                        contenido.ReadLine();
                        line=contenido.ReadLine();
                        this.resultado[contador].descripcion = devolverDescripcion(line);
                        final = final + this.resultado[contador].titulo + this.resultado[contador].URL+this.resultado[contador].descripcion +"\n";
                        //listaURL[contador] = URL;
                        
                        contador++;
                    }
                }
               
            }
           
            return final+contador.ToString() + " links encontrados.";
            //ahora buscar devuelve solo el numero de links encontrados, pero llama a dos funciones k devuelven el titulo  y la URL
        }


        private string devolverUrl(string linea) {
            
            int posicion;


            posicion = linea.IndexOf("'>");

            string URL = linea.Remove(posicion);
           

            URL.Replace("'", "");
            return URL + "\n";

        }

        private string devolverTitulo(string linea) {
            int posicion;
           
            //string titulo = string.Empty;
            string   aux;

           posicion= linea.LastIndexOf(">");
           linea =linea.Remove(posicion);
           linea=linea.Replace("</a", "");
           linea=linea.Replace("</span>", "");
            
           posicion= linea.IndexOf("<span");
           if (posicion > 0){
               aux = linea.Substring(posicion);     
               posicion = aux.IndexOf(">");          
               aux = aux.Remove(posicion);
               linea = linea.Replace(aux, "");
           }
           linea = linea.Replace(">", "");

            return linea+"\n";

        }

        private string devolverDescripcion(string linea) {
            
            int posicion;
            string aux;
            posicion = linea.LastIndexOf(">");
            linea = linea.Remove(posicion);
            linea = linea.Replace("</span>", "");

            posicion = linea.IndexOf("<span");
            while (posicion > 0)
            {
                aux = linea.Substring(posicion);
                posicion = aux.IndexOf(">");
                aux = aux.Remove(posicion);
                linea = linea.Replace(aux, "");
                posicion=linea.IndexOf("<span");
            }
            posicion = linea.IndexOf("&#");
            while (posicion>0){
                
                aux = linea.Substring(posicion);
                posicion=aux.IndexOf(";");
                aux.Remove(posicion);
                linea.Replace(aux, "");
                posicion = linea.IndexOf("&#");
            
            }

            linea = linea.Replace(">", "");
            return linea + "\n";
        }

        //El metodo de abajo no funciona evidentemente porque el codigo fuente de codeplex es html
        //[WebMethod]

        //public string buscarConXml(string palabras)
        //{
        //    StreamReader contenido = leerPaginaWeb("http://www.codeplex.com/site/search?projectSearchText=" + palabras + "&sortBy=Relevance&licenses=|");
        //    XmlDocument Docu = new XmlDocument();
        //    Docu.Load(contenido);
        //    XmlNodeList Items=Docu.SelectNodes("tr class/td/div/a");
        //    string URL=string.Empty;
        //    string final = string.Empty;
        //    string titulo = string.Empty;
        //    for(int i=0;i<Items.Count;i++){
        //       URL=Items.Item(i).InnerText;
        //       final = final + URL + "\n";
 

        //    }

        //    return final;

            //return string.Empty;


        //}
        //A IMPLEMENTAR!!!!!!!!!!!!!!!!!
        //[WebMethod]
        //public string nextPage() { 
        //}
        //[WebMethod]

        //public bool isnextPage() { 
        //}
         






        static private StreamReader leerPaginaWeb(string laUrl)
        {
            // Cear la solicitud de la URL.
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(laUrl);

            // Obtener la respuesta.
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();

            // Abrir el stream de la respuesta recibida.


            StreamReader reader = new StreamReader(response.GetResponseStream());

            // Leer el contenido.

            // string res = reader.ReadToEnd();

            // Mostrarlo.

            return reader;
            // Cerrar los streams abiertos.
            reader.Close();
            response.Close();

        }
    }
}