﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;

namespace FlujoTags
{
    class GestorBusqueda
    {
        public string motorBusqueda;
        public string web;
        public string Palabras;
        //Para el flujo le tengo que pasar la web donde registrar
        private SPWeb miWeb;

        int encontrados, registrados;
        // Aunque funciona es mejor que haga un gestor que cogiendo el string de cada busqueda, te lo separe y mande la busqueda a cada motor


        public GestorBusqueda(string stringBusqueda, string Palabras)
        {
            this.Palabras = Palabras;
            this.registrados = 0;
            if (stringBusqueda.Contains(":"))
            {

                this.motorBusqueda = stringBusqueda.Remove(stringBusqueda.IndexOf(":"));

                this.web = stringBusqueda.Substring(stringBusqueda.IndexOf(":") + 1).Trim(); ;


            }
            else
            {
                this.motorBusqueda = stringBusqueda;
                this.web = "HTML custom";


            }


        }


        public GestorBusqueda(string motorBusqueda, string web, string Palabras,SPWeb miWeb)
        {
            this.motorBusqueda = motorBusqueda;
            this.web = web;
            this.Palabras = Palabras;
            this.miWeb = miWeb;
            this.registrados = 0;
            this.encontrados = 0;
        }

        //   public GestorBusqueda(string motorBusqueda, string Palabras) {
        //    this.motorBusqueda = motorBusqueda;
        //    this.Palabras = Palabras;
        //    web = "HTML custom";
        //    this.registrados = 0;
        //}





        public GestorBusqueda buscar()
        {
            if (this.motorBusqueda.Equals("Yahoo"))
            {
                YahooSearch busquedaYahoo = new YahooSearch(this.web, this.Palabras,miWeb);
                this.encontrados = busquedaYahoo.buscar();
                this.registrados = busquedaYahoo.registrados;

            }

            if (this.motorBusqueda.Equals("Bing"))
            {

                BingSearch busquedaBing = new BingSearch(this.web, this.Palabras,miWeb);
                this.encontrados = busquedaBing.buscar();
                this.registrados = busquedaBing.registrados;

            }
           

            return this;
        }

        public int getResultados()
        {
            return this.registrados;
        }
        public int getEncontrados()
        {
            return this.encontrados;
        }

    }
}
