﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using System.Reflection;
using System.Xml;
using Microsoft.SharePoint.Client;
using System.Xml.Serialization;



[assembly: System.Web.UI.WebResource("JSEliminarNewItem.js", "text / javascript")] 

namespace ReferentesExternosVistas.ExternViewsWebPart
{
    [ToolboxItemAttribute(true)]
    [ToolboxData("<{0}:ExternViewsWebPart runat=server></{0}:ExternViewsWebPart>")]
    [Microsoft.SharePoint.Security.SharePointPermission(System.Security.Permissions.SecurityAction.LinkDemand, ObjectModel = true)]
    [System.Web.AspNetHostingPermission(System.Security.Permissions.SecurityAction.LinkDemand, Level = System.Web.AspNetHostingPermissionLevel.Minimal)]
    [XmlRoot(Namespace = "ExternViewsWebPart")]
    public class ExternViewsWebPart : Microsoft.SharePoint.WebPartPages.WebPart
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/ReferentesExternosVistas/ExternViewsWebPart/ExternViewsWebPartUserControl.ascx";
        SPSite miSitio;
        Label debugger;
        string Tag,vista;
        Label info;
        XsltListViewWebPart xslListwp;
        //Button linKLista;

        string rows = "15";
        string rowsAprobados = "10";
        [Bindable(true)]
        [Category("Referentes Setting")]
        [DefaultValue("")]
        [Localizable(true)]
        [Description("Escriba el numero de resultados aprobados que desea mostrar en la web part")]
        public string FilasAprobadas
        {
            get
            {
                return ((this.rowsAprobados == null) ? String.Empty : this.rowsAprobados);
            }

            set
            {
                this.rowsAprobados = value;
            }
        }

        [Bindable(true)]
        [Category("Referentes Setting")]
        [DefaultValue("")]
        [Localizable(true)]
        [Description("Escriba el numero de resultados pendientes que desea mostrar en la web part")]
       
        
        public string FilasPendientes
        {
            get
            {
                return ((this.rows == null) ? String.Empty : this.rows);
            }

            set
            {
                this.rows =value;
            }
        }
        LinkButton vermas;
        

        public ExternViewsWebPart()
        {
            try
            {
                //En currentSite obtengo el SPSite de mi sitio web de SharePoint
                miSitio = SPControl.GetContextSite(HttpContext.Current);
                
            }
            catch (Exception ex)
            {
                Label l1 = new Label();
                l1.Text = ex.Message;
            }
        }

      
        protected override void CreateChildControls()
        {
          

            

                debugger = new Label();
                Controls.Add(debugger);



                BuscarPorTag();





                Control control = this.Page.LoadControl(_ascxPath);
                Controls.Add(control);
                base.CreateChildControls();
            
            
           

           

            
        }


      

        protected override void RenderContents(HtmlTextWriter writer)
        {
            base.RenderContents(writer);
        }


        void BuscarPorTag() {

            int posicion;
            string aux = Page.Request.Url.ToString();
            aux=aux.Replace("%23", "#");
           
           

            //Si  no contiene tags= significa que no ha seleccionado ninguno previamente
            if (!aux.Contains("tags="))
            {

                debugger.Text = "<br> No hay ningun elemento seleccionado en la nube";
               
               
            }
            else
            { //Miro cual es el tag 

                if (aux.Contains("&View="))
                {
                    vista = aux.Substring(aux.IndexOf("&View="));
                    posicion = aux.IndexOf("tags=");
                    Tag = aux.Substring(posicion);
                    Tag = Tag.Replace("tags=", "");
                    Tag = Tag.Replace(vista, "");

                    //lo q kiero acer es un string vista donde este la direccion 
                }
                else
                {
                    posicion = aux.IndexOf("tags=");
                    Tag = aux.Substring(posicion);
                    Tag = Tag.Replace("tags=", "");
                    vista="Vista-de-" + Tag;
                }
                debugger.Text = "<br> Referencias encontradas para: <b>" + Tag + "</b>";

                

                //Error aqui mirar mañana haber k kojones pasa
                //SPWeb miWeb = miSitio.OpenWeb();
                SPWeb miWeb = SPControl.GetContextWeb(Context);
                SPList miLista = miWeb.Lists["RegistroBusqueda"];
               
             
                try
                {
                    //Aqui compruebo si las vistas para ese tag estan creadas, si lo estan lo muestro, si no salta la excepcion
                    SPView miVistaPendientes = miLista.Views["Vista-de-" + Tag];
                    SPView miVistaAprobados = miLista.Views["Vista-de-" + Tag + "-aprobados"];
                    debugger.Text = debugger.Text + "<br> Mostrando vista de referentes aprobados";
                    mostrarVistas(Tag);
                }
                catch
                {
                    //Aqui las creo y las muestro


                   debugger.Text = debugger.Text + "<br> Validando tag...";
                   bool validado= validarTag(Tag);
                    if (validado){

                        debugger.Text = debugger.Text + "<br> creando vistas...";
                        crearVistas(Tag);
                    
                    }
                    else
                        debugger.Text = debugger.Text + "<br><br> <b>No existe niguna referencia para " +Tag;

                }
                //Aqui abajo inicializo la vista de aprobacion de pendientes y la pongo invisible por ahora
                
                

                info = new Label();
                info.Text = "<br> <br> Seleccione los que desee aprobar y pulse el boton";
                info.Visible = false;
                Controls.Add(info);

                try


                {
                    miWeb.AllowUnsafeUpdates=true;
                    SPView miVista=miLista.Views["Vista-de-"+Tag];
                    
                    miVista.RowLimit=(uint)Int32.Parse(rows);
                    miVista.Paged = false;
                    miVista.TabularView = false;
                    miVista.InlineEdit = "TRUE";
                    miVista.Update();
                    //miLista.Update();
                   // miWeb.Update();
                         

                    xslListwp = new XsltListViewWebPart();
                    xslListwp.ListName = miLista.ID.ToString("B").ToUpper();
                    xslListwp.ViewGuid = miVista.ID.ToString("B").ToUpper();
                   
                    
                    xslListwp.Visible = false;
                    

                   
                    this.Controls.Add(xslListwp);

                    //linKLista = new Button();
                    
                    //linKLista.Text = "Ver más referentes";
                    //linKLista.Click += new EventHandler(botonLink_Click);
                    //linKLista.BorderStyle = BorderStyle.None;
                    //linKLista.Visible = false;
                   // this.Controls.Add(linKLista);


                    vermas = new LinkButton();
                    vermas.Visible = false;
                 
                    vermas.Click+=new EventHandler(vermas_Click);
                    
                    vermas.Text = "<br><b>Ver todo<b>";
                    //if (!(Page.Request.Url.ToString().Contains("&View")))
                    
                    //    vermas.PostBackUrl = Page.Request.Url+"&View={" + miVista.ID.ToString("B").ToUpper() + "}&Paged=TRUE&p_ID=1384&PageFirstRow=17";
                    //else
                    //    vermas.PostBackUrl= Page.Request.Url+"&Paged=TRUE&p_ID=1384&PageFirstRow=17";
                    
                    
                    this.Controls.Add(vermas);
                    //xslListwp.Controls.Add(linKLista);

                }
                catch (Exception ex) { string excep=ex.Message; }
               
               

                
            }

        
        }

        void mostrarVistas(string tag) {
            try
            {

               
                SPWeb miWeb = SPControl.GetContextWeb(Context);
                SPList miLista = miWeb.Lists["RegistroBusqueda"];
                ListViewWebPart listwp = new ListViewWebPart();

                miWeb.AllowUnsafeUpdates = true;
                SPViewCollection vistas = miLista.Views;
                
                SPView misAprobados = vistas["Vista-de-" + tag + "-aprobados"];
                //SPView misAprobados = miLista.Views["Vista de " + Tag + " aprobados"];

                misAprobados.Paged = false;
                misAprobados.RowLimit = (uint)Int32.Parse(rowsAprobados);
                misAprobados.Update();
                
              
                //Aqui muestro mi vista!
                XsltListViewWebPart xslListwp=new XsltListViewWebPart();

               // xslListwp.ListUrl = miWeb.Url;
                xslListwp.ListName =miLista.ID.ToString("B").ToUpper();
                xslListwp.ViewGuid=misAprobados.ID.ToString("B").ToUpper();
                xslListwp.AllowEdit = false;
                
               
                this.Controls.Add(xslListwp);
                
                
                Button boton = new Button();
                boton.Text = "Aprobar/Editar referencias";

                boton.Click += new EventHandler(botonVer_Click);
                xslListwp.Controls.Add(boton);
                
               
               
            }
            catch (Exception ex) {
                string mensaje = ex.Message;
                debugger.Text = debugger.Text+"<br>" +mensaje;
            }
           
        
        
        }
        
        
        bool crearVistas(string tag)
        {
            try
            {
                SPWeb miWeb = miSitio.OpenWeb();
                miWeb.AllowUnsafeUpdates = true;

                SPListCollection misListas = miWeb.Lists;
                SPList listaRegistros = misListas["RegistroBusqueda"];
                SPQuery miQuery = new SPQuery();

                miQuery.Query = "<Where><Contains><FieldRef Name='posibles_x0020_tags'/>" + "<Value Type='Text'>" + tag + "</Value></Contains></Where>";

                SPQuery miQuery2 = new SPQuery();
                miQuery2.Query = "<Where><And><Eq><FieldRef Name='Aprobacion'/>" + "<Value Type='Choice'>Aprobado</Value></Eq>" + "<Contains><FieldRef Name='posibles_x0020_tags'/>" + "<Value Type='Text'>" + tag + "</Value></Contains></And></Where>";

                System.Collections.Specialized.StringCollection collViewFields = new System.Collections.Specialized.StringCollection();
                collViewFields.Add("Título");
                collViewFields.Add("URL");
                collViewFields.Add("descripcion");
                collViewFields.Add("posibles tags");
                collViewFields.Add("Aprobacion");
                
                string titulo = "Vista-de-" + tag;
                string titulo2 = titulo + "-aprobados";
                SPView VistaPendientes = listaRegistros.Views.Add(titulo, collViewFields, miQuery.Query,(uint)Int32.Parse(rows), false, false);

                VistaPendientes.TabularView = false;
                VistaPendientes.Update();
                VistaPendientes.InlineEdit = "TRUE";
                VistaPendientes.Update();
                collViewFields.Clear();
                collViewFields.Add("Título");
                collViewFields.Add("URL");
                collViewFields.Add("descripcion");
                //collViewFields.Add("posibles tags");

                SPView VistaAprobados = listaRegistros.Views.Add(titulo2, collViewFields, miQuery2.Query, (uint)Int32.Parse(rowsAprobados), false, false);
                VistaAprobados.TabularView = false;
                VistaAprobados.Paged = false;
                VistaAprobados.Update();
                //SPViewFieldCollection misFields=VistaAprobados.ViewFields;
                //SPField miCampo=new SPField
                //misFields.Add(
               

                HyperLink refresh = new HyperLink();
                refresh.Text = "<br>Actualize para ver los referentes";
                refresh.NavigateUrl = Page.Request.Url.ToString();
                Controls.Add(refresh);

                //XsltListViewWebPart xslListwp = new XsltListViewWebPart();
                //xslListwp.ListName = listaRegistros.ID.ToString("B").ToUpper();
                //xslListwp.ViewGuid = VistaAprobados.ID.ToString("B").ToUpper();
                //xslListwp.AllowEdit = false;
                //this.Controls.Add(xslListwp);




                return true;
            }
            catch (Exception ex)
            {
                string message = ex.Message;

                return false;
            }

        }

        void botonVer_Click(object sender, EventArgs e)
        {

            SPWeb miWeb = SPControl.GetContextWeb(Context);
            SPList miLista = miWeb.Lists["RegistroBusqueda"];

            vermas.Visible = true;
            

            
            if (xslListwp.Visible == false)
            {
                info.Visible = true;
                xslListwp.Visible = true;
                //linKLista.Visible = true;
               



            }
            else
            {



                debugger.Text = debugger.Text + "<br> Cambios realizados";




            }







        }
    
        void vermas_Click(object sender, EventArgs e) {
          
            SPWeb miWeb = SPControl.GetContextWeb(Context);
            SPList miLista = miWeb.Lists["RegistroBusqueda"];

            miWeb.AllowUnsafeUpdates = true;
          
           
            SPView Vista = miLista.Views["Vista-de-" + Tag];

  
           
           Vista.Paged = true;
           Vista.TabularView = true;
           Vista.Update();
            
  
           Page.Response.Redirect(miSitio.Url + "/Lists/RegistroBusqueda/Vistade" + Tag.Replace("#","") + ".aspx");
               
            
           
            
          

            
           
        }

        //void botonLink_Click(object sender, EventArgs e)
        //{



        //    SPWeb miWeb = SPControl.GetContextWeb(Context);
        //    SPList miLista = miWeb.Lists["RegistroBusqueda"];
        //    SPView Vista = miLista.Views["Vista-de-" + Tag];
        //    miWeb.AllowUnsafeUpdates = true;
        //    Vista.Paged = true;
        //    Vista.TabularView = true;
        //    Vista.Update();
        //    //miLista.Update();
        //    //miWeb.Update();
        //    Page.Response.Redirect(miSitio.Url + "/Lists/RegistroBusqueda/Vistade" + Tag + ".aspx");
        //}


        public bool  validarTag(string Tag) {
            SPList miLista = miSitio.OpenWeb().Lists["RegistroBusqueda"];
            foreach (SPListItem item in miLista.GetItems()) {
                if (item["posibles tags"] != null)
                {
                    string[] tagsSep = item["posibles tags"].ToString().Split(',');

                    foreach (string tagItem in tagsSep)
                    {
                        if (tagItem.ToUpper().Contains(Tag.ToUpper()))
                            return true;
                    }

                }
            }
            
            return false;

        }
    }
}
