﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;


namespace ConsoleXML
{
    class ItemXML
    {

        private string _title;
        private string _link;
        private string _contenido;

        public string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        public string Link
        {
            get { return _link; }
            set { _link = value; }
        }

        public string Contenido
        {
            get { return _contenido; }
            set { _contenido = value; }
        }

    }

    

    class RssManager
    {



        public static System.Collections.ArrayList ProcessNewsFeed(string rssURL)
        {
            // Begin the WebRequest to the desired RSS Feed
            System.Net.WebRequest myRequest = System.Net.WebRequest.Create(rssURL);
            System.Net.WebResponse myResponse = myRequest.GetResponse();

            // Convert the RSS Feed into an XML document
            System.IO.Stream rssStream = myResponse.GetResponseStream();
            System.Xml.XmlDocument rssDoc = new System.Xml.XmlDocument();

            rssDoc.Load(rssStream);

            // This uses an XPath expression to get all nodes that fall 
            // under this path.
            System.Xml.XmlNodeList rssItems = rssDoc.SelectNodes("rss/channel/item");
           
            /* 
             * I'll use the new ItemXML class instead.  No need for these anymore:
             * 
            string title = "";
            string link = "";
            string contenido = "";
             */ 

            // Loop through the Item nodes from the RSS Feed and retrieve 
            // the Title, Link and contenido.  Then we'll add it to the
            // database (if not already present.)

            System.Collections.ArrayList returnArrayList = new System.Collections.ArrayList();

            for (int i = 0; i < rssItems.Count; i++)
            {
                System.Xml.XmlNode rssDetail;

                ItemXML tempItemXML = new ItemXML();

                rssDetail = rssItems.Item(i).SelectSingleNode("title");
                if (rssDetail != null)
                {
                    tempItemXML.Title = rssDetail.InnerText;  
                }
                else
                {
                    tempItemXML.Title = "";
                }

                rssDetail = rssItems.Item(i).SelectSingleNode("link");
                if (rssDetail != null)
                {
                    tempItemXML.Link = rssDetail.InnerText;
                }
                else
                {
                    tempItemXML.Link = "";
                }

                rssDetail = rssItems.Item(i).SelectSingleNode("description");
                
                
                if (rssDetail != null)
                {

                    //tempItemXML.Contenido=rssDetail.nod
                    System.Xml.XmlNodeList listaProyectos = rssDetail.ChildNodes;
                        //rssDetail.SelectNodes("li");

                    foreach (System.Xml.XmlNode nodo in listaProyectos){
                        tempItemXML.Contenido = tempItemXML.Contenido + "\n" +nodo.Name+ "--->"+ nodo.InnerText;

                    
                    }

                   

                  
                    //Con la funcion  bool  b=rssDetail.HasChildNodes; he comprobado que tenga child nodes y si los tiene 
                    
                    //pa luego pa avanzar
                   
                    //System.Xml.XmlNode primerNodo=rssDetail.FirstChild;
                    //tempItemXML.Contenido = primerNodo.InnerText;
                    
                }
                else
                {
                    tempItemXML.Contenido = "";
                }

                returnArrayList.Add(tempItemXML);

            }

            return returnArrayList;

        }

    }
}


    

