﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using miAplicacionBing.BingService;

namespace miAplicacionBing
{
    class Program
    {
        static void Main(string[] args)
        {

            string AppId = "F216C49337B833B66A684083C08DF1B9A6CAE891"; // enter your AppId key here!
            string query;
            Console.WriteLine("Escriba la query a buscar");
            query = Console.ReadLine();
           
            Console.WriteLine("Escriba la página en la que desee buscar");
            string site = Console.ReadLine();

            query = query + " site:" + site;


            using (BingPortTypeClient client = new BingPortTypeClient())
            {
                var request = new SearchRequest();

                request.AppId = AppId;
                request.Sources = new SourceType[] { SourceType.Web };
                request.Query = query;

                SearchResponse response = client.Search(request);
                
                if (response.Web != null && response.Web.Results.Count() > 0)
                {
                    var pos = 0;

                    foreach (var r in response.Web.Results)
                    {
                        pos++;

                        Console.WriteLine(pos + ". " + r.Title);
                        Console.WriteLine(r.Url);
                        Console.WriteLine(r.Description);
                        
                        //Aqui abajo la busqueda de tags devuelve tags normales pero tambien muy extraños

                        WebSearchTag[] Tags;  //=new WebSearchTag[10];
                        Tags = r.SearchTags;
                        if (Tags != null)
                        {
                            foreach (WebSearchTag tag in Tags)
                            {
                                Console.Write(tag.Value + ", ");

                            }
                        }
                        

                        Console.WriteLine();
                    }
                }
            }

            Console.ReadLine();


        }
    }
}
